﻿using System;
using System.Runtime.InteropServices;
using System.Windows.Forms;
using Microsoft.WindowsMobile.Status;

namespace IntelegentLocker
{
    public partial class MainForm : Form
    {
        private const string REG_KEY_UNREAD_SMS_COUNT = @"HKEY_LOCAL_MACHINE\System\State\Messages\SMS\Unread";
        private const string REG_VALUE_UNREAD_SMS_COUNT = "Count";

        RegistryState unreadSmsCountWatcher = null;
        SystemState missedCallCountWatcher = null;

        private int unreadSmsCount = 0;
        private int missedCallCount = 0;

        public MainForm()
        {
            InitializeComponent();
        }

        private void InializeObject()
        {
            unreadSmsCountWatcher = new RegistryState(REG_KEY_UNREAD_SMS_COUNT, REG_VALUE_UNREAD_SMS_COUNT);
            missedCallCountWatcher = new SystemState(SystemProperty.PhoneMissedCalls, true);
        }

        private void SetEventHandler()
        {
            unreadSmsCountWatcher.Changed += new ChangeEventHandler(UnreadSmsCountChanged);
            missedCallCountWatcher.Changed += new ChangeEventHandler(MissedCallCountChanged);
        }

        private void RunLockApplication()
        {
            //잠금키 누름
            SystemCalls.SendKey(SystemCalls.VK_F22);
        }

        private void UnreadSmsCountChanged(object sender, ChangeEventArgs args)
        {
            int newUnreadSmscount = 0;
            newUnreadSmscount = (int)args.NewValue;

            if (newUnreadSmscount > unreadSmsCount)
                RunLockApplication();

            unreadSmsCount = newUnreadSmscount;
        }

        private void MissedCallCountChanged(object sender, ChangeEventArgs args)
        {
            int newMissedCallCount = 0;
            newMissedCallCount = SystemState.PhoneMissedCalls;

            if (newMissedCallCount > missedCallCount)
                RunLockApplication();

            missedCallCount = newMissedCallCount;
        }

        private void MainForm_Load(object sender, EventArgs e)
        {
            InializeObject();
            SetEventHandler();

            timer1.Interval = 1000;
            timer1.Enabled = true;
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            timer1.Enabled = false;
            this.Hide();
        }
    }

    public class SystemCalls
    {
        //See more at http://msdn2.microsoft.com/en-us/library/ms927178.aspx
        public const byte VK_NONAME = 0xFC;  // Do nothing
        public const byte VK_ESC = 0x1B;  // Smartphone back-button
        public const byte VK_F4 = 0x73;  // Home Screen
        public const byte VK_APP6 = 0xC6;  // Lock the keys on Smartphone
        public const byte VK_F22 = 0x85;  // Lock the keys on PocketPC (VK_KEYLOCK)
        public const byte VK_F16 = 0x7F;  // Toggle Speakerphone
        public const byte VK_OFF = 0xDF;  // Power button

        /// <summary>
        /// Puts `key` into to global keyboard buffer
        /// </summary>
        /// <param name="key"></param>
        public static void SendKey(byte key)
        {
            const int KEYEVENTF_KEYUP = 0x02;
            const int KEYEVENTF_KEYDOWN = 0x00;
            keybd_event(key, 0, KEYEVENTF_KEYDOWN, 0);
            keybd_event(key, 0, KEYEVENTF_KEYUP, 0);
        }

        [DllImport("coredll", SetLastError = true)]
        private static extern void keybd_event(byte bVk, byte bScan, int dwFlags, int dwExtraInfo);
    }
}